/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-05 16:09:48 UTC)
 * on 2013-06-19 at 01:08:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.civicinfo;

/**
 * Service definition for CivicInfo (us_v1).
 *
 * <p>
 * An API for accessing civic information.
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="https://developers.google.com/civic-information" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link CivicInfoRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class CivicInfo extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    com.google.api.client.util.Preconditions.checkState(
        com.google.api.client.googleapis.GoogleUtils.MAJOR_VERSION == 1 &&
        com.google.api.client.googleapis.GoogleUtils.MINOR_VERSION == 14,
        "You are currently running with version %s of google-api-client. " +
        "You need version 1.14 of google-api-client to run version " +
        "1.14.2-beta of the Google Civic Information API library.", com.google.api.client.googleapis.GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://www.googleapis.com/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "civicinfo/us_v1/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   */
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport, which should normally be:
   *        <ul>
   *        <li>Google App Engine:
   *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
   *        <li>Android: {@code newCompatibleTransport} from
   *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
   *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
   *        </li>
   *        </ul>
   * @param jsonFactory JSON factory, which may be:
   *        <ul>
   *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
   *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
   *        <li>Android Honeycomb or higher:
   *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
   *        </ul>
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public CivicInfo(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
      com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
    this(new Builder(transport, jsonFactory, httpRequestInitializer));
  }

  /**
   * @param builder builder
   */
  CivicInfo(Builder builder) {
    super(builder);
  }

  @Override
  protected void initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * An accessor for creating requests from the Elections collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code CivicInfo civicinfo = new CivicInfo(...);}
   *   {@code CivicInfo.Elections.List request = civicinfo.elections().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Elections elections() {
    return new Elections();
  }

  /**
   * The "elections" collection of methods.
   */
  public class Elections {

    /**
     * List of available elections to query.
     *
     * Create a request for the method "elections.electionQuery".
     *
     * This request holds the parameters needed by the the civicinfo server.  After setting any optional
     * parameters, call the {@link ElectionQuery#execute()} method to invoke the remote operation.
     *
     * @return the request
     */
    public ElectionQuery electionQuery() throws java.io.IOException {
      ElectionQuery result = new ElectionQuery();
      initialize(result);
      return result;
    }

    public class ElectionQuery extends CivicInfoRequest<com.google.api.services.civicinfo.model.ElectionsQueryResponse> {

      private static final String REST_PATH = "elections";

      /**
       * List of available elections to query.
       *
       * Create a request for the method "elections.electionQuery".
       *
       * This request holds the parameters needed by the the civicinfo server.  After setting any
       * optional parameters, call the {@link ElectionQuery#execute()} method to invoke the remote
       * operation. <p> {@link ElectionQuery#initialize(com.google.api.client.googleapis.services.Abstra
       * ctGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @since 1.13
       */
      protected ElectionQuery() {
        super(CivicInfo.this, "GET", REST_PATH, null, com.google.api.services.civicinfo.model.ElectionsQueryResponse.class);
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public ElectionQuery setAlt(java.lang.String alt) {
        return (ElectionQuery) super.setAlt(alt);
      }

      @Override
      public ElectionQuery setFields(java.lang.String fields) {
        return (ElectionQuery) super.setFields(fields);
      }

      @Override
      public ElectionQuery setKey(java.lang.String key) {
        return (ElectionQuery) super.setKey(key);
      }

      @Override
      public ElectionQuery setOauthToken(java.lang.String oauthToken) {
        return (ElectionQuery) super.setOauthToken(oauthToken);
      }

      @Override
      public ElectionQuery setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (ElectionQuery) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public ElectionQuery setQuotaUser(java.lang.String quotaUser) {
        return (ElectionQuery) super.setQuotaUser(quotaUser);
      }

      @Override
      public ElectionQuery setUserIp(java.lang.String userIp) {
        return (ElectionQuery) super.setUserIp(userIp);
      }

      @Override
      public ElectionQuery set(String parameterName, Object value) {
        return (ElectionQuery) super.set(parameterName, value);
      }
    }
    /**
     * Looks up information relevant to a voter based on the voter's registered address.
     *
     * Create a request for the method "elections.voterInfoQuery".
     *
     * This request holds the parameters needed by the the civicinfo server.  After setting any optional
     * parameters, call the {@link VoterInfoQuery#execute()} method to invoke the remote operation.
     *
     * @param electionId The unique ID of the election to look up. A list of election IDs can be obtained
     *        at.https://www.googleapis.com/civicinfo/{version}/elections
     * @param content the {@link com.google.api.services.civicinfo.model.VoterInfoRequest}
     * @return the request
     */
    public VoterInfoQuery voterInfoQuery(java.lang.Long electionId, com.google.api.services.civicinfo.model.VoterInfoRequest content) throws java.io.IOException {
      VoterInfoQuery result = new VoterInfoQuery(electionId, content);
      initialize(result);
      return result;
    }

    public class VoterInfoQuery extends CivicInfoRequest<com.google.api.services.civicinfo.model.VoterInfoResponse> {

      private static final String REST_PATH = "voterinfo/{electionId}/lookup";

      /**
       * Looks up information relevant to a voter based on the voter's registered address.
       *
       * Create a request for the method "elections.voterInfoQuery".
       *
       * This request holds the parameters needed by the the civicinfo server.  After setting any
       * optional parameters, call the {@link VoterInfoQuery#execute()} method to invoke the remote
       * operation. <p> {@link VoterInfoQuery#initialize(com.google.api.client.googleapis.services.Abstr
       * actGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param electionId The unique ID of the election to look up. A list of election IDs can be obtained
     *        at.https://www.googleapis.com/civicinfo/{version}/elections
       * @param content the {@link com.google.api.services.civicinfo.model.VoterInfoRequest}
       * @since 1.13
       */
      protected VoterInfoQuery(java.lang.Long electionId, com.google.api.services.civicinfo.model.VoterInfoRequest content) {
        super(CivicInfo.this, "POST", REST_PATH, content, com.google.api.services.civicinfo.model.VoterInfoResponse.class);
        this.electionId = com.google.api.client.util.Preconditions.checkNotNull(electionId, "Required parameter electionId must be specified.");
      }

      @Override
      public VoterInfoQuery setAlt(java.lang.String alt) {
        return (VoterInfoQuery) super.setAlt(alt);
      }

      @Override
      public VoterInfoQuery setFields(java.lang.String fields) {
        return (VoterInfoQuery) super.setFields(fields);
      }

      @Override
      public VoterInfoQuery setKey(java.lang.String key) {
        return (VoterInfoQuery) super.setKey(key);
      }

      @Override
      public VoterInfoQuery setOauthToken(java.lang.String oauthToken) {
        return (VoterInfoQuery) super.setOauthToken(oauthToken);
      }

      @Override
      public VoterInfoQuery setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (VoterInfoQuery) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public VoterInfoQuery setQuotaUser(java.lang.String quotaUser) {
        return (VoterInfoQuery) super.setQuotaUser(quotaUser);
      }

      @Override
      public VoterInfoQuery setUserIp(java.lang.String userIp) {
        return (VoterInfoQuery) super.setUserIp(userIp);
      }

      /**
       * The unique ID of the election to look up. A list of election IDs can be obtained
       * at.https://www.googleapis.com/civicinfo/{version}/elections
       */
      @com.google.api.client.util.Key
      private java.lang.Long electionId;

      /** The unique ID of the election to look up. A list of election IDs can be obtained
     at.https://www.googleapis.com/civicinfo/{version}/elections
       */
      public java.lang.Long getElectionId() {
        return electionId;
      }

      /**
       * The unique ID of the election to look up. A list of election IDs can be obtained
       * at.https://www.googleapis.com/civicinfo/{version}/elections
       */
      public VoterInfoQuery setElectionId(java.lang.Long electionId) {
        this.electionId = electionId;
        return this;
      }

      /** If set to true, only data from official state sources will be returned. */
      @com.google.api.client.util.Key
      private java.lang.Boolean officialOnly;

      /** If set to true, only data from official state sources will be returned. [default: false]
       */
      public java.lang.Boolean getOfficialOnly() {
        return officialOnly;
      }

      /** If set to true, only data from official state sources will be returned. */
      public VoterInfoQuery setOfficialOnly(java.lang.Boolean officialOnly) {
        this.officialOnly = officialOnly;
        return this;
      }

      /**
       * Convenience method that returns only {@link Boolean#TRUE} or {@link Boolean#FALSE}.
       *
       * <p>
       * Boolean properties can have four possible values:
       * {@code null}, {@link com.google.api.client.util.Data#NULL_BOOLEAN}, {@link Boolean#TRUE}
       * or {@link Boolean#FALSE}.
       * </p>
       *
       * <p>
       * This method returns {@link Boolean#TRUE} if the default of the property is {@link Boolean#TRUE}
       * and it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
       * {@link Boolean#FALSE} is returned if the default of the property is {@link Boolean#FALSE} and
       * it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
       * </p>
       *
       * <p>
       * If set to true, only data from official state sources will be returned.
       * </p>
       */
      public boolean isOfficialOnly() {
        if (officialOnly == null || officialOnly == com.google.api.client.util.Data.NULL_BOOLEAN) {
          return false;
        }
        return officialOnly;
      }

      @Override
      public VoterInfoQuery set(String parameterName, Object value) {
        return (VoterInfoQuery) super.set(parameterName, value);
      }
    }

  }

  /**
   * An accessor for creating requests from the Representatives collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code CivicInfo civicinfo = new CivicInfo(...);}
   *   {@code CivicInfo.Representatives.List request = civicinfo.representatives().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Representatives representatives() {
    return new Representatives();
  }

  /**
   * The "representatives" collection of methods.
   */
  public class Representatives {

    /**
     * Looks up political geography and (optionally) representative information based on an address.
     *
     * Create a request for the method "representatives.representativeInfoQuery".
     *
     * This request holds the parameters needed by the the civicinfo server.  After setting any optional
     * parameters, call the {@link RepresentativeInfoQuery#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.civicinfo.model.RepresentativeInfoRequest}
     * @return the request
     */
    public RepresentativeInfoQuery representativeInfoQuery(com.google.api.services.civicinfo.model.RepresentativeInfoRequest content) throws java.io.IOException {
      RepresentativeInfoQuery result = new RepresentativeInfoQuery(content);
      initialize(result);
      return result;
    }

    public class RepresentativeInfoQuery extends CivicInfoRequest<com.google.api.services.civicinfo.model.RepresentativeInfoResponse> {

      private static final String REST_PATH = "representatives/lookup";

      /**
       * Looks up political geography and (optionally) representative information based on an address.
       *
       * Create a request for the method "representatives.representativeInfoQuery".
       *
       * This request holds the parameters needed by the the civicinfo server.  After setting any
       * optional parameters, call the {@link RepresentativeInfoQuery#execute()} method to invoke the
       * remote operation. <p> {@link RepresentativeInfoQuery#initialize(com.google.api.client.googleapi
       * s.services.AbstractGoogleClientRequest)} must be called to initialize this instance immediately
       * after invoking the constructor. </p>
       *
       * @param content the {@link com.google.api.services.civicinfo.model.RepresentativeInfoRequest}
       * @since 1.13
       */
      protected RepresentativeInfoQuery(com.google.api.services.civicinfo.model.RepresentativeInfoRequest content) {
        super(CivicInfo.this, "POST", REST_PATH, content, com.google.api.services.civicinfo.model.RepresentativeInfoResponse.class);
      }

      @Override
      public RepresentativeInfoQuery setAlt(java.lang.String alt) {
        return (RepresentativeInfoQuery) super.setAlt(alt);
      }

      @Override
      public RepresentativeInfoQuery setFields(java.lang.String fields) {
        return (RepresentativeInfoQuery) super.setFields(fields);
      }

      @Override
      public RepresentativeInfoQuery setKey(java.lang.String key) {
        return (RepresentativeInfoQuery) super.setKey(key);
      }

      @Override
      public RepresentativeInfoQuery setOauthToken(java.lang.String oauthToken) {
        return (RepresentativeInfoQuery) super.setOauthToken(oauthToken);
      }

      @Override
      public RepresentativeInfoQuery setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (RepresentativeInfoQuery) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public RepresentativeInfoQuery setQuotaUser(java.lang.String quotaUser) {
        return (RepresentativeInfoQuery) super.setQuotaUser(quotaUser);
      }

      @Override
      public RepresentativeInfoQuery setUserIp(java.lang.String userIp) {
        return (RepresentativeInfoQuery) super.setUserIp(userIp);
      }

      /**
       * Whether to return information about offices and officials. If false, only the top-level
       * district information will be returned.
       */
      @com.google.api.client.util.Key
      private java.lang.Boolean includeOffices;

      /** Whether to return information about offices and officials. If false, only the top-level district
     information will be returned. [default: true]
       */
      public java.lang.Boolean getIncludeOffices() {
        return includeOffices;
      }

      /**
       * Whether to return information about offices and officials. If false, only the top-level
       * district information will be returned.
       */
      public RepresentativeInfoQuery setIncludeOffices(java.lang.Boolean includeOffices) {
        this.includeOffices = includeOffices;
        return this;
      }

      /**
       * Convenience method that returns only {@link Boolean#TRUE} or {@link Boolean#FALSE}.
       *
       * <p>
       * Boolean properties can have four possible values:
       * {@code null}, {@link com.google.api.client.util.Data#NULL_BOOLEAN}, {@link Boolean#TRUE}
       * or {@link Boolean#FALSE}.
       * </p>
       *
       * <p>
       * This method returns {@link Boolean#TRUE} if the default of the property is {@link Boolean#TRUE}
       * and it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
       * {@link Boolean#FALSE} is returned if the default of the property is {@link Boolean#FALSE} and
       * it is {@code null} or {@link com.google.api.client.util.Data#NULL_BOOLEAN}.
       * </p>
       *
       * <p>
       * Whether to return information about offices and officials. If false, only the top-level district
     information will be returned.
       * </p>
       */
      public boolean isIncludeOffices() {
        if (includeOffices == null || includeOffices == com.google.api.client.util.Data.NULL_BOOLEAN) {
          return true;
        }
        return includeOffices;
      }

      @Override
      public RepresentativeInfoQuery set(String parameterName, Object value) {
        return (RepresentativeInfoQuery) super.set(parameterName, value);
      }
    }

  }

  /**
   * Builder for {@link CivicInfo}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport, which should normally be:
     *        <ul>
     *        <li>Google App Engine:
     *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
     *        <li>Android: {@code newCompatibleTransport} from
     *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
     *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
     *        </li>
     *        </ul>
     * @param jsonFactory JSON factory, which may be:
     *        <ul>
     *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
     *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
     *        <li>Android Honeycomb or higher:
     *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
     *        </ul>
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
        com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link CivicInfo}. */
    @Override
    public CivicInfo build() {
      return new CivicInfo(this);
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    @Override
    public Builder setSuppressRequiredParameterChecks(boolean suppressRequiredParameterChecks) {
      return (Builder) super.setSuppressRequiredParameterChecks(suppressRequiredParameterChecks);
    }

    @Override
    public Builder setSuppressAllChecks(boolean suppressAllChecks) {
      return (Builder) super.setSuppressAllChecks(suppressAllChecks);
    }

    /**
     * Set the {@link CivicInfoRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setCivicInfoRequestInitializer(
        CivicInfoRequestInitializer civicinfoRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(civicinfoRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        com.google.api.client.googleapis.services.GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
